
/****************************************************************************
 * Copyright Software Kinetics Ltd.
 * 
 * Software Kinetics Ltd. has granted a licence of this software to
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve,
 * reproduce and sell the software.
 *
 * The software is provided to the user "as is" without warranty of
 * any kind.  Neither Software Kinetics Ltd. nor the National Library
 * of Canada warrants,guarantees or makes any representation regarding
 * the use, or the results of the use of the software in terms of
 * accuracy,reliability, or otherwise.  The entire risk as results and
 * performance of the software is assumed by the user. Neither
 * Software Kinetics Ltd. nor the National Library of Canada shall be
 * liable for any direct, indirect, consequential or incidental
 * damages arising out the use of software.
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 *
 * HEADER apdu.h
 *
 * PURPOSE:
 *    This header file contains the definitions for all of the IR
 *    APDU services.
 *
 * SCOPE:
 *    All CSCs that use IR service data types must include this
 *    file. 
 *
 * $Header: /mnt/users/irorigin/sdl/system/./headers/RCS/apdu.h,v 1.1 1993/01/26 20:51:45 irorigin Allocated irorigin $
 * $Log: apdu.h,v $
 * Revision 1.1  1993/01/26  20:51:45  irorigin
 * Initial revision
 *
 * 
 ****************************************************************************/

#ifndef IR_APDU_H

#define IR_APDU_H
#include "asn_incl.h"

/*
 *    ir.h
 *
 *    "IR" ASN.1 module C type definitions and prototypes
 *
 *    This .h file was by snacc on Fri Mar 19 13:31:54 1993
 *
 *    UBC snacc written compiler by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */


#ifndef _ir_h_
#define _ir_h_

#ifdef VMS
#define BDecDeleteResultSetReqSeqOfContent    BDecDelResultSetReqSeqOfContent
#define BEncDeleteResultSetReqSeqOfContent    BEncDelResultSetReqSeqOfContent
#define BDecElementSetNamesSeqOfSeqContent    BDecElemSetNamesSeqOfSeqContent
#define BEncElementSetNamesSeqOfSeqContent    BEncElemSetNamesSeqOfSeqContent
#endif



#define SUCCESS 0
#define PARTIAL 1
#define FAILURE_1 2
#define FAILURE_2 3
#define FAILURE_3 4
#define FAILURE_4 5

typedef AsnInt ResourceReportRespInt; /* INTEGER { SUCCESS(0), PARTIAL(1), FAILURE_1(2), FAILURE_2(3), FAILURE_3(4), FAILURE_4(5) }  */

#define BEncResourceReportRespIntContent BEncAsnIntContent

#define BDecResourceReportRespIntContent BDecAsnIntContent

#define PrintResourceReportRespInt PrintAsnInt

#define FreeResourceReportRespInt FreeAsnInt 





#define RESOURCEREPORT 1
#define RESOURCECONTROL 2
#define CANCEL 3

typedef AsnInt TriggerResourceReqInt; /* INTEGER { RESOURCEREPORT(1), RESOURCECONTROL(2), CANCEL(3) }  */

#define BEncTriggerResourceReqIntContent BEncAsnIntContent

#define BDecTriggerResourceReqIntContent BDecAsnIntContent

#define PrintTriggerResourceReqInt PrintAsnInt

#define FreeTriggerResourceReqInt FreeAsnInt 





#define SUBSET 1
#define INTERIM 2
#define NONE 3

typedef AsnInt ResourceControlReqInt; /* INTEGER { SUBSET(1), INTERIM(2), NONE(3) }  */

#define BEncResourceControlReqIntContent BEncAsnIntContent

#define BDecResourceControlReqIntContent BDecAsnIntContent

#define PrintResourceControlReqInt PrintAsnInt

#define FreeResourceControlReqInt FreeAsnInt 





#define LIST 0
#define ALL 1

typedef AsnInt DeleteResultSetReqInt; /* INTEGER { LIST(0), ALL(1) }  */

#define BEncDeleteResultSetReqIntContent BEncAsnIntContent

#define BDecDeleteResultSetReqIntContent BDecAsnIntContent

#define PrintDeleteResultSetReqInt PrintAsnInt

#define FreeDeleteResultSetReqInt FreeAsnInt 





#define SUBSET1 1
#define INTERIM1 2
#define NONE1 3

typedef AsnInt SearchRespInt; /* INTEGER { SUBSET1(1), INTERIM1(2), NONE1(3) }  */

#define BEncSearchRespIntContent BEncAsnIntContent

#define BDecSearchRespIntContent BDecAsnIntContent

#define PrintSearchRespInt PrintAsnInt

#define FreeSearchRespInt FreeAsnInt 




typedef AsnBits ProtocolVersion; /* [3] IMPLICIT BIT STRING */

#define BEncProtocolVersionContent BEncAsnBitsContent

#define BDecProtocolVersionContent BDecAsnBitsContent

#define PrintProtocolVersion PrintAsnBits

#define FreeProtocolVersion FreeAsnBits 





#define SEARCH 0
#define PRESENT 1
#define DELSET 2
#define RESOURCEREPORT1 3
#define TRIGGERRESOURCECTRL 4
#define RESOURCECTRL 5
#define ACCESSCTRL 6

typedef AsnBits Options; /* [4] IMPLICIT BIT STRING { SEARCH(0), PRESENT(1), DELSET(2), RESOURCEREPORT1(3), TRIGGERRESOURCECTRL(4), RESOURCECTRL(5), ACCESSCTRL(6) }  */

#define BEncOptionsContent BEncAsnBitsContent

#define BDecOptionsContent BDecAsnBitsContent

#define PrintOptions PrintAsnBits

#define FreeOptions FreeAsnBits 




typedef AsnInt PreferredMessageSize; /* [5] IMPLICIT INTEGER */

#define BEncPreferredMessageSizeContent BEncAsnIntContent

#define BDecPreferredMessageSizeContent BDecAsnIntContent

#define PrintPreferredMessageSize PrintAsnInt

#define FreePreferredMessageSize FreeAsnInt 




typedef AsnInt MaximumRecordSize; /* [6] IMPLICIT INTEGER */

#define BEncMaximumRecordSizeContent BEncAsnIntContent

#define BDecMaximumRecordSizeContent BDecAsnIntContent

#define PrintMaximumRecordSize PrintAsnInt

#define FreeMaximumRecordSize FreeAsnInt 




typedef AsnOcts Term; /* [45] IMPLICIT OCTET STRING */

#define BEncTermContent BEncAsnOctsContent

#define BDecTermContent BDecAsnOctsContent

#define PrintTerm PrintAsnOcts

#define FreeTerm FreeAsnOcts 




typedef AsnInt AttributeType; /* [120] IMPLICIT INTEGER */

#define BEncAttributeTypeContent BEncAsnIntContent

#define BDecAttributeTypeContent BDecAsnIntContent

#define PrintAttributeType PrintAsnInt

#define FreeAttributeType FreeAsnInt 




typedef AsnInt AttributeValue; /* [121] IMPLICIT INTEGER */

#define BEncAttributeValueContent BEncAsnIntContent

#define BDecAttributeValueContent BDecAsnIntContent

#define PrintAttributeValue PrintAsnInt

#define FreeAttributeValue FreeAsnInt 




typedef AsnInt NumRecordsReturned; /* [24] IMPLICIT INTEGER */

#define BEncNumRecordsReturnedContent BEncAsnIntContent

#define BDecNumRecordsReturnedContent BDecAsnIntContent

#define PrintNumRecordsReturned PrintAsnInt

#define FreeNumRecordsReturned FreeAsnInt 




typedef AsnInt NextResultSetPosition; /* [25] IMPLICIT INTEGER */

#define BEncNextResultSetPositionContent BEncAsnIntContent

#define BDecNextResultSetPositionContent BDecAsnIntContent

#define PrintNextResultSetPosition PrintAsnInt

#define FreeNextResultSetPosition FreeAsnInt 





#define SUCCESS1 0
#define PARTIAL_1 1
#define PARTIAL_2 2
#define PARTIAL_3 3
#define PARTIAL_4 4
#define FAILURE 5

typedef AsnInt PresentStatus; /* [27] IMPLICIT INTEGER { SUCCESS1(0), PARTIAL_1(1), PARTIAL_2(2), PARTIAL_3(3), PARTIAL_4(4), FAILURE(5) }  */

#define BEncPresentStatusContent BEncAsnIntContent

#define BDecPresentStatusContent BDecAsnIntContent

#define PrintPresentStatus PrintAsnInt

#define FreePresentStatus FreeAsnInt 




typedef AsnOid PreferredRecordSyntax; /* [104] IMPLICIT OBJECT IDENTIFIER */

#define BEncPreferredRecordSyntaxContent BEncAsnOidContent

#define BDecPreferredRecordSyntaxContent BDecAsnOidContent

#define PrintPreferredRecordSyntax PrintAsnOid

#define FreePreferredRecordSyntax FreeAsnOid 





#define SUCCESS2 0
#define RESULTSETDIDNOTEXIST 1
#define PREVIOUSLYDELETEDBYTARGET 2
#define SYSTEMPROBLEMATTARGET 3
#define ACCESSNOTALLOWED 4
#define RESOURCECONTROLATORIGIN 5
#define RESOURCECONTROLATTARGET 6
#define BULKDELETENOTSUPPORTED 7
#define NOTALLRSLTSDELETEDONBULK 8
#define NOTALLREQUESTEDRSLTSDELETED 9

typedef AsnInt DeleteSetStatus; /* [33] IMPLICIT INTEGER { SUCCESS2(0), RESULTSETDIDNOTEXIST(1), PREVIOUSLYDELETEDBYTARGET(2), SYSTEMPROBLEMATTARGET(3), ACCESSNOTALLOWED(4), RESOURCECONTROLATORIGIN(5), RESOURCECONTROLATTARGET(6), BULKDELETENOTSUPPORTED(7), NOTALLRSLTSDELETEDONBULK(8), NOTALLREQUESTEDRSLTSDELETED(9) }  */

#define BEncDeleteSetStatusContent BEncAsnIntContent

#define BDecDeleteSetStatusContent BDecAsnIntContent

#define PrintDeleteSetStatus PrintAsnInt

#define FreeDeleteSetStatus FreeAsnInt 




typedef AsnOid ResourceReportId; /* OBJECT IDENTIFIER */

#define BEncResourceReportIdContent BEncAsnOidContent

#define BDecResourceReportIdContent BDecAsnOidContent

#define PrintResourceReportId PrintAsnOid

#define FreeResourceReportId FreeAsnOid 




typedef AsnOcts ReferenceId; /* [2] IMPLICIT OCTET STRING */

#define BEncReferenceIdContent BEncAsnOctsContent

#define BDecReferenceIdContent BDecAsnOctsContent

#define PrintReferenceId PrintAsnOcts

#define FreeReferenceId FreeAsnOcts 




typedef VisibleString ImplementationId; /* [110] IMPLICIT VisibleString */

AsnLen BEncImplementationId PROTO((BUF_TYPE b, ImplementationId* v));

void BDecImplementationId PROTO(( BUF_TYPE b, ImplementationId* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncImplementationIdContent BEncVisibleStringContent

#define BDecImplementationIdContent BDecVisibleStringContent

#define PrintImplementationId PrintVisibleString

#define FreeImplementationId FreeVisibleString 




typedef VisibleString ImplementationName; /* [111] IMPLICIT VisibleString */

AsnLen BEncImplementationName PROTO((BUF_TYPE b, ImplementationName* v));

void BDecImplementationName PROTO(( BUF_TYPE b, ImplementationName* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncImplementationNameContent BEncVisibleStringContent

#define BDecImplementationNameContent BDecVisibleStringContent

#define PrintImplementationName PrintVisibleString

#define FreeImplementationName FreeVisibleString 




typedef VisibleString ImplementationVersion; /* [112] IMPLICIT VisibleString */

AsnLen BEncImplementationVersion PROTO((BUF_TYPE b, ImplementationVersion* v));

void BDecImplementationVersion PROTO(( BUF_TYPE b, ImplementationVersion* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncImplementationVersionContent BEncVisibleStringContent

#define BDecImplementationVersionContent BDecVisibleStringContent

#define PrintImplementationVersion PrintVisibleString

#define FreeImplementationVersion FreeVisibleString 




typedef struct EXTERNAL UserInfoField; /* [11] EXTERNAL */

AsnLen BEncUserInfoField PROTO((BUF_TYPE b, UserInfoField* v));

void BDecUserInfoField PROTO(( BUF_TYPE b, UserInfoField* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncUserInfoFieldContent BEncEXTERNALContent

#define BDecUserInfoFieldContent BDecEXTERNALContent

#define PrintUserInfoField PrintEXTERNAL

#define FreeUserInfoField FreeEXTERNAL 




typedef struct Operator /* [46] CHOICE */
{
    enum OperatorChoiceId
    {
        OPERATOR_AND,
        OPERATOR_OR,
        OPERATOR_AND_NOT
    } choiceId;
    union OperatorChoiceUnion
    {
    AsnNull and; /* [0] IMPLICIT NULL */
    AsnNull or; /* [1] IMPLICIT NULL */
    AsnNull and_not; /* [2] IMPLICIT NULL */
    } a;
} Operator;

AsnLen BEncOperatorContent PROTO((BUF_TYPE b, Operator* v));

void BDecOperatorContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Operator* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintOperator PROTO((FILE* f, Operator* v, unsigned short int indent));
void FreeOperator PROTO((Operator* v));





typedef struct EXTERNAL DatabaseRecord; /* EXTERNAL */

#define BEncDatabaseRecord BEncEXTERNAL
#define BDecDatabaseRecord BDecEXTERNAL
#define BEncDatabaseRecordContent BEncEXTERNALContent

#define BDecDatabaseRecordContent BDecEXTERNALContent

#define PrintDatabaseRecord PrintEXTERNAL

#define FreeDatabaseRecord FreeEXTERNAL 




typedef struct DiagRec /* SEQUENCE */
{
    AsnOid diagnosticSetId; /* OBJECT IDENTIFIER */
    AsnInt condition; /* INTEGER */
    VisibleString addInfo; /* VisibleString */
} DiagRec;

AsnLen BEncDiagRecContent PROTO((BUF_TYPE b, DiagRec* v));

void BDecDiagRecContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, DiagRec* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintDiagRec PROTO((FILE* f, DiagRec* v, unsigned short int indent));
void FreeDiagRec PROTO((DiagRec* v));





typedef VisibleString ElementSetName; /* [103] IMPLICIT VisibleString */

AsnLen BEncElementSetName PROTO((BUF_TYPE b, ElementSetName* v));

void BDecElementSetName PROTO(( BUF_TYPE b, ElementSetName* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncElementSetNameContent BEncVisibleStringContent

#define BDecElementSetNameContent BDecVisibleStringContent

#define PrintElementSetName PrintVisibleString

#define FreeElementSetName FreeVisibleString 




typedef struct SecurityParameter /* CHOICE */
{
    enum SecurityParameterChoiceId
    {
        SECURITYPARAMETER_OLDWAY,
        SECURITYPARAMETER_NEWWAY
    } choiceId;
    union SecurityParameterChoiceUnion
    {
    AsnOcts* oldway; /* OCTET STRING */
    struct EXTERNAL* newway; /* EXTERNAL */
    } a;
} SecurityParameter;

AsnLen BEncSecurityParameterContent PROTO((BUF_TYPE b, SecurityParameter* v));

void BDecSecurityParameterContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SecurityParameter* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintSecurityParameter PROTO((FILE* f, SecurityParameter* v, unsigned short int indent));
void FreeSecurityParameter PROTO((SecurityParameter* v));





typedef struct EXTERNAL ResourceReport; /* EXTERNAL */

#define BEncResourceReport BEncEXTERNAL
#define BDecResourceReport BDecEXTERNAL
#define BEncResourceReportContent BEncEXTERNALContent

#define BDecResourceReportContent BDecEXTERNALContent

#define PrintResourceReport PrintEXTERNAL

#define FreeResourceReport FreeEXTERNAL 




typedef VisibleString DatabaseName; /* [105] IMPLICIT VisibleString */

AsnLen BEncDatabaseName PROTO((BUF_TYPE b, DatabaseName* v));

void BDecDatabaseName PROTO(( BUF_TYPE b, DatabaseName* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncDatabaseNameContent BEncVisibleStringContent

#define BDecDatabaseNameContent BDecVisibleStringContent

#define PrintDatabaseName PrintVisibleString

#define FreeDatabaseName FreeVisibleString 




typedef VisibleString ResultSetId; /* [31] IMPLICIT VisibleString */

AsnLen BEncResultSetId PROTO((BUF_TYPE b, ResultSetId* v));

void BDecResultSetId PROTO(( BUF_TYPE b, ResultSetId* result, AsnLen* bytesDecoded, ENV_TYPE env));
#define BEncResultSetIdContent BEncVisibleStringContent

#define BDecResultSetIdContent BDecVisibleStringContent

#define PrintResultSetId PrintVisibleString

#define FreeResultSetId FreeVisibleString 




typedef struct ListStatusesSeq /* SEQUENCE */
{
    ResultSetId resultSetId; /* ResultSetId */
    DeleteSetStatus deleteSetStatus; /* DeleteSetStatus */
} ListStatusesSeq;

AsnLen BEncListStatusesSeqContent PROTO((BUF_TYPE b, ListStatusesSeq* v));

void BDecListStatusesSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ListStatusesSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintListStatusesSeq PROTO((FILE* f, ListStatusesSeq* v, unsigned short int indent));
void FreeListStatusesSeq PROTO((ListStatusesSeq* v));





typedef AsnList DeleteResultSetReqSeqOf; /* SEQUENCE OF ResultSetId */

AsnLen BEncDeleteResultSetReqSeqOfContent PROTO((BUF_TYPE b, DeleteResultSetReqSeqOf* v));

void BDecDeleteResultSetReqSeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, DeleteResultSetReqSeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintDeleteResultSetReqSeqOf PROTO((FILE* f, DeleteResultSetReqSeqOf* v, unsigned short int indent));
void FreeDeleteResultSetReqSeqOf PROTO((DeleteResultSetReqSeqOf* v));





typedef struct ElementSetNamesSeqOfSeq /* SEQUENCE */
{
    DatabaseName databaseName; /* DatabaseName */
    ElementSetName elementSetName; /* ElementSetName */
} ElementSetNamesSeqOfSeq;

AsnLen BEncElementSetNamesSeqOfSeqContent PROTO((BUF_TYPE b, ElementSetNamesSeqOfSeq* v));

void BDecElementSetNamesSeqOfSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ElementSetNamesSeqOfSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintElementSetNamesSeqOfSeq PROTO((FILE* f, ElementSetNamesSeqOfSeq* v, unsigned short int indent));
void FreeElementSetNamesSeqOfSeq PROTO((ElementSetNamesSeqOfSeq* v));





typedef AsnList ElementSetNamesSeqOf; /* SEQUENCE OF ElementSetNamesSeqOfSeq */

AsnLen BEncElementSetNamesSeqOfContent PROTO((BUF_TYPE b, ElementSetNamesSeqOf* v));

void BDecElementSetNamesSeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ElementSetNamesSeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintElementSetNamesSeqOf PROTO((FILE* f, ElementSetNamesSeqOf* v, unsigned short int indent));
void FreeElementSetNamesSeqOf PROTO((ElementSetNamesSeqOf* v));





typedef struct NamePlusRecordChoice /* CHOICE */
{
    enum NamePlusRecordChoiceChoiceId
    {
        NAMEPLUSRECORDCHOICE_DATABASERECORD,
        NAMEPLUSRECORDCHOICE_SURROGATEDIAGNOSTIC
    } choiceId;
    union NamePlusRecordChoiceChoiceUnion
    {
    DatabaseRecord* databaseRecord; /* [1] DatabaseRecord */
    struct DiagRec* surrogateDiagnostic; /* [2] DiagRec */
    } a;
} NamePlusRecordChoice;

AsnLen BEncNamePlusRecordChoiceContent PROTO((BUF_TYPE b, NamePlusRecordChoice* v));

void BDecNamePlusRecordChoiceContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, NamePlusRecordChoice* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintNamePlusRecordChoice PROTO((FILE* f, NamePlusRecordChoice* v, unsigned short int indent));
void FreeNamePlusRecordChoice PROTO((NamePlusRecordChoice* v));





typedef AsnList SearchReqSeqOf; /* SEQUENCE OF DatabaseName */

AsnLen BEncSearchReqSeqOfContent PROTO((BUF_TYPE b, SearchReqSeqOf* v));

void BDecSearchReqSeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SearchReqSeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintSearchReqSeqOf PROTO((FILE* f, SearchReqSeqOf* v, unsigned short int indent));
void FreeSearchReqSeqOf PROTO((SearchReqSeqOf* v));





typedef struct InitializeReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    ProtocolVersion protocolVersion; /* ProtocolVersion */
    Options options; /* Options */
    PreferredMessageSize preferredMessageSize; /* PreferredMessageSize */
    MaximumRecordSize maximumRecordSize; /* MaximumRecordSize */
    VisibleString idAuthentication; /* [7] VisibleString OPTIONAL */
    ImplementationId implementationId; /* ImplementationId OPTIONAL */
    ImplementationName implementationName; /* ImplementationName OPTIONAL */
    ImplementationVersion implementationVersion; /* ImplementationVersion OPTIONAL */
    UserInfoField* userInfoField; /* UserInfoField OPTIONAL */
} InitializeReq;

AsnLen BEncInitializeReqContent PROTO((BUF_TYPE b, InitializeReq* v));

void BDecInitializeReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, InitializeReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintInitializeReq PROTO((FILE* f, InitializeReq* v, unsigned short int indent));
void FreeInitializeReq PROTO((InitializeReq* v));





typedef struct InitializeResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    ProtocolVersion protocolVersion; /* ProtocolVersion */
    Options options; /* Options */
    PreferredMessageSize preferredMessageSize; /* PreferredMessageSize */
    MaximumRecordSize maximumRecordSize; /* MaximumRecordSize */
    AsnBool result; /* [12] IMPLICIT BOOLEAN */
    ImplementationId implementationId; /* ImplementationId OPTIONAL */
    ImplementationName implementationName; /* ImplementationName OPTIONAL */
    ImplementationVersion implementationVersion; /* ImplementationVersion OPTIONAL */
    UserInfoField* userInfoField; /* UserInfoField OPTIONAL */
} InitializeResp;

AsnLen BEncInitializeRespContent PROTO((BUF_TYPE b, InitializeResp* v));

void BDecInitializeRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, InitializeResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintInitializeResp PROTO((FILE* f, InitializeResp* v, unsigned short int indent));
void FreeInitializeResp PROTO((InitializeResp* v));





typedef struct AttributeElement /* SEQUENCE */
{
    AttributeType attributeType; /* AttributeType */
    AttributeValue attributeValue; /* AttributeValue */
} AttributeElement;

AsnLen BEncAttributeElementContent PROTO((BUF_TYPE b, AttributeElement* v));

void BDecAttributeElementContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AttributeElement* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAttributeElement PROTO((FILE* f, AttributeElement* v, unsigned short int indent));
void FreeAttributeElement PROTO((AttributeElement* v));





typedef struct NamePlusRecord /* SEQUENCE */
{
    DatabaseName databaseName; /* [0] IMPLICIT DatabaseName OPTIONAL */
    struct NamePlusRecordChoice* namePlusRecordChoice; /* [1] NamePlusRecordChoice */
} NamePlusRecord;

AsnLen BEncNamePlusRecordContent PROTO((BUF_TYPE b, NamePlusRecord* v));

void BDecNamePlusRecordContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, NamePlusRecord* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintNamePlusRecord PROTO((FILE* f, NamePlusRecord* v, unsigned short int indent));
void FreeNamePlusRecord PROTO((NamePlusRecord* v));





typedef struct ElementSetNames /* [19] CHOICE */
{
    enum ElementSetNamesChoiceId
    {
        ELEMENTSETNAMES_GENERIC,
        ELEMENTSETNAMES_DATABASESPECIFIC
    } choiceId;
    union ElementSetNamesChoiceUnion
    {
    ElementSetName* generic; /* [0] IMPLICIT ElementSetName */
    ElementSetNamesSeqOf* databaseSpecific; /* [1] IMPLICIT ElementSetNamesSeqOf */
    } a;
} ElementSetNames;

AsnLen BEncElementSetNamesContent PROTO((BUF_TYPE b, ElementSetNames* v));

void BDecElementSetNamesContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ElementSetNames* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintElementSetNames PROTO((FILE* f, ElementSetNames* v, unsigned short int indent));
void FreeElementSetNames PROTO((ElementSetNames* v));





typedef struct DeleteResultSetReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    DeleteResultSetReqInt deleteOperation; /* [32] IMPLICIT DeleteResultSetReqInt */
    DeleteResultSetReqSeqOf* resultSetList; /* DeleteResultSetReqSeqOf OPTIONAL */
} DeleteResultSetReq;

AsnLen BEncDeleteResultSetReqContent PROTO((BUF_TYPE b, DeleteResultSetReq* v));

void BDecDeleteResultSetReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, DeleteResultSetReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintDeleteResultSetReq PROTO((FILE* f, DeleteResultSetReq* v, unsigned short int indent));
void FreeDeleteResultSetReq PROTO((DeleteResultSetReq* v));





typedef AsnList ListStatuses; /* SEQUENCE OF ListStatusesSeq */

AsnLen BEncListStatusesContent PROTO((BUF_TYPE b, ListStatuses* v));

void BDecListStatusesContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ListStatuses* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintListStatuses PROTO((FILE* f, ListStatuses* v, unsigned short int indent));
void FreeListStatuses PROTO((ListStatuses* v));





typedef struct AccessControlReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    struct SecurityParameter* securityChallenge; /* [37] SecurityParameter */
} AccessControlReq;

AsnLen BEncAccessControlReqContent PROTO((BUF_TYPE b, AccessControlReq* v));

void BDecAccessControlReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AccessControlReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAccessControlReq PROTO((FILE* f, AccessControlReq* v, unsigned short int indent));
void FreeAccessControlReq PROTO((AccessControlReq* v));





typedef struct AccessControlResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    struct SecurityParameter* secChallengeResp; /* [38] SecurityParameter */
} AccessControlResp;

AsnLen BEncAccessControlRespContent PROTO((BUF_TYPE b, AccessControlResp* v));

void BDecAccessControlRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AccessControlResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAccessControlResp PROTO((FILE* f, AccessControlResp* v, unsigned short int indent));
void FreeAccessControlResp PROTO((AccessControlResp* v));





typedef struct ResourceControlReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    AsnBool* suspendedFlag; /* [39] IMPLICIT BOOLEAN OPTIONAL */
    ResourceReport* resourceReport; /* [40] ResourceReport OPTIONAL */
    ResourceControlReqInt* partialResultsAvailable; /* [41] IMPLICIT ResourceControlReqInt OPTIONAL */
    AsnBool responseRequired; /* [42] IMPLICIT BOOLEAN */
    AsnBool* triggeredRequestFlag; /* [43] IMPLICIT BOOLEAN OPTIONAL */
} ResourceControlReq;

AsnLen BEncResourceControlReqContent PROTO((BUF_TYPE b, ResourceControlReq* v));

void BDecResourceControlReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceControlReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceControlReq PROTO((FILE* f, ResourceControlReq* v, unsigned short int indent));
void FreeResourceControlReq PROTO((ResourceControlReq* v));





typedef struct ResourceControlResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    AsnBool continueFlag; /* [44] IMPLICIT BOOLEAN */
    AsnBool* resultSetWanted; /* [45] IMPLICIT BOOLEAN OPTIONAL */
} ResourceControlResp;

AsnLen BEncResourceControlRespContent PROTO((BUF_TYPE b, ResourceControlResp* v));

void BDecResourceControlRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceControlResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceControlResp PROTO((FILE* f, ResourceControlResp* v, unsigned short int indent));
void FreeResourceControlResp PROTO((ResourceControlResp* v));





typedef struct TriggerResourceReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    TriggerResourceReqInt requestedOperation; /* [46] IMPLICIT TriggerResourceReqInt */
    ResourceReportId preferredRsrcRprtFmt; /* [47] IMPLICIT ResourceReportId OPTIONAL */
    AsnBool* resultSetWanted; /* [48] IMPLICIT BOOLEAN OPTIONAL */
} TriggerResourceReq;

AsnLen BEncTriggerResourceReqContent PROTO((BUF_TYPE b, TriggerResourceReq* v));

void BDecTriggerResourceReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, TriggerResourceReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintTriggerResourceReq PROTO((FILE* f, TriggerResourceReq* v, unsigned short int indent));
void FreeTriggerResourceReq PROTO((TriggerResourceReq* v));





typedef struct ResourceReportReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    ResourceReportId preferredRsrcRprtFmt; /* [49] IMPLICIT ResourceReportId OPTIONAL */
} ResourceReportReq;

AsnLen BEncResourceReportReqContent PROTO((BUF_TYPE b, ResourceReportReq* v));

void BDecResourceReportReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReportReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReportReq PROTO((FILE* f, ResourceReportReq* v, unsigned short int indent));
void FreeResourceReportReq PROTO((ResourceReportReq* v));





typedef struct ResourceReportResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    ResourceReportRespInt resourceReportStatus; /* [50] IMPLICIT ResourceReportRespInt */
    ResourceReport* resourceReport; /* [51] ResourceReport OPTIONAL */
} ResourceReportResp;

AsnLen BEncResourceReportRespContent PROTO((BUF_TYPE b, ResourceReportResp* v));

void BDecResourceReportRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ResourceReportResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintResourceReportResp PROTO((FILE* f, ResourceReportResp* v, unsigned short int indent));
void FreeResourceReportResp PROTO((ResourceReportResp* v));





typedef AsnList RecordsSeqOf; /* SEQUENCE OF NamePlusRecord */

AsnLen BEncRecordsSeqOfContent PROTO((BUF_TYPE b, RecordsSeqOf* v));

void BDecRecordsSeqOfContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, RecordsSeqOf* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintRecordsSeqOf PROTO((FILE* f, RecordsSeqOf* v, unsigned short int indent));
void FreeRecordsSeqOf PROTO((RecordsSeqOf* v));





typedef AsnList AttributeList; /* [44] IMPLICIT SEQUENCE OF AttributeElement */

AsnLen BEncAttributeListContent PROTO((BUF_TYPE b, AttributeList* v));

void BDecAttributeListContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AttributeList* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAttributeList PROTO((FILE* f, AttributeList* v, unsigned short int indent));
void FreeAttributeList PROTO((AttributeList* v));





typedef struct PresentReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    ResultSetId resultSetId; /* ResultSetId */
    AsnInt resultSetStartPoint; /* [30] IMPLICIT INTEGER */
    AsnInt numRecordsRequested; /* [29] IMPLICIT INTEGER */
    struct ElementSetNames* elementSetNames; /* ElementSetNames OPTIONAL */
    PreferredRecordSyntax preferredRecordSyntax; /* PreferredRecordSyntax OPTIONAL */
} PresentReq;

AsnLen BEncPresentReqContent PROTO((BUF_TYPE b, PresentReq* v));

void BDecPresentReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PresentReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPresentReq PROTO((FILE* f, PresentReq* v, unsigned short int indent));
void FreePresentReq PROTO((PresentReq* v));





typedef struct Records /* CHOICE */
{
    enum RecordsChoiceId
    {
        RECORDS_DBORSURDIAGNOSTICS,
        RECORDS_NONSURDIAGNOSTICS
    } choiceId;
    union RecordsChoiceUnion
    {
    RecordsSeqOf* dbOrSurDiagnostics; /* [28] IMPLICIT RecordsSeqOf */
    struct DiagRec* nonSurDiagnostics; /* [130] IMPLICIT DiagRec */
    } a;
} Records;

AsnLen BEncRecordsContent PROTO((BUF_TYPE b, Records* v));

void BDecRecordsContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Records* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintRecords PROTO((FILE* f, Records* v, unsigned short int indent));
void FreeRecords PROTO((Records* v));





typedef struct DeleteResultSetResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    DeleteSetStatus deleteOperStatus; /* [0] IMPLICIT DeleteSetStatus */
    ListStatuses* deleteListStatuses; /* [1] IMPLICIT ListStatuses OPTIONAL */
    AsnInt* numberNotDeleted; /* [34] IMPLICIT INTEGER OPTIONAL */
    ListStatuses* bulkStatuses; /* [35] IMPLICIT ListStatuses OPTIONAL */
    VisibleString deleteMessage; /* [36] IMPLICIT VisibleString OPTIONAL */
} DeleteResultSetResp;

AsnLen BEncDeleteResultSetRespContent PROTO((BUF_TYPE b, DeleteResultSetResp* v));

void BDecDeleteResultSetRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, DeleteResultSetResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintDeleteResultSetResp PROTO((FILE* f, DeleteResultSetResp* v, unsigned short int indent));
void FreeDeleteResultSetResp PROTO((DeleteResultSetResp* v));





typedef struct AttributePlusTerm /* [102] IMPLICIT SEQUENCE */
{
    AttributeList* attributeList; /* AttributeList */
    Term term; /* Term */
} AttributePlusTerm;

AsnLen BEncAttributePlusTermContent PROTO((BUF_TYPE b, AttributePlusTerm* v));

void BDecAttributePlusTermContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, AttributePlusTerm* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAttributePlusTerm PROTO((FILE* f, AttributePlusTerm* v, unsigned short int indent));
void FreeAttributePlusTerm PROTO((AttributePlusTerm* v));





typedef struct SearchResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    AsnInt resultCount; /* [23] IMPLICIT INTEGER */
    NumRecordsReturned numRecordsReturned; /* NumRecordsReturned */
    NextResultSetPosition nextResultSetPosition; /* NextResultSetPosition */
    AsnBool searchStatus; /* [22] IMPLICIT BOOLEAN */
    SearchRespInt* resultSetStatus; /* [26] IMPLICIT SearchRespInt OPTIONAL */
    PresentStatus* presentStatus; /* PresentStatus OPTIONAL */
    struct Records* dbOrDiagnosticRec; /* Records OPTIONAL */
} SearchResp;

AsnLen BEncSearchRespContent PROTO((BUF_TYPE b, SearchResp* v));

void BDecSearchRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SearchResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintSearchResp PROTO((FILE* f, SearchResp* v, unsigned short int indent));
void FreeSearchResp PROTO((SearchResp* v));





typedef struct PresentResp /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    NumRecordsReturned numRecordsReturned; /* NumRecordsReturned */
    NextResultSetPosition nextResultSetPosition; /* NextResultSetPosition */
    PresentStatus* presentStatus; /* PresentStatus OPTIONAL */
    struct Records* dbOrDiagnosticRec; /* Records OPTIONAL */
} PresentResp;

AsnLen BEncPresentRespContent PROTO((BUF_TYPE b, PresentResp* v));

void BDecPresentRespContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PresentResp* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintPresentResp PROTO((FILE* f, PresentResp* v, unsigned short int indent));
void FreePresentResp PROTO((PresentResp* v));





typedef struct Operand /* CHOICE */
{
    enum OperandChoiceId
    {
        OPERAND_ATTRIBUTEPLUSTERM,
        OPERAND_RESULTSETID
    } choiceId;
    union OperandChoiceUnion
    {
    struct AttributePlusTerm* attributePlusTerm; /* AttributePlusTerm */
    ResultSetId* resultSetId; /* ResultSetId */
    } a;
} Operand;

AsnLen BEncOperandContent PROTO((BUF_TYPE b, Operand* v));

void BDecOperandContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Operand* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintOperand PROTO((FILE* f, Operand* v, unsigned short int indent));
void FreeOperand PROTO((Operand* v));





typedef struct RPNStructureSeq /* SEQUENCE */
{
    struct RPNStructure* rPNStructure; /* RPNStructure */
    struct RPNStructure* rPNStructure1; /* RPNStructure */
    struct Operator* operator; /* Operator */
} RPNStructureSeq;

AsnLen BEncRPNStructureSeqContent PROTO((BUF_TYPE b, RPNStructureSeq* v));

void BDecRPNStructureSeqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, RPNStructureSeq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintRPNStructureSeq PROTO((FILE* f, RPNStructureSeq* v, unsigned short int indent));
void FreeRPNStructureSeq PROTO((RPNStructureSeq* v));





typedef struct RPNStructure /* CHOICE */
{
    enum RPNStructureChoiceId
    {
        RPNSTRUCTURE_OPERAND,
        RPNSTRUCTURE_RPNSTRUCTURESEQ
    } choiceId;
    union RPNStructureChoiceUnion
    {
    struct Operand* operand; /* [0] Operand */
    struct RPNStructureSeq* rPNStructureSeq; /* [1] IMPLICIT RPNStructureSeq */
    } a;
} RPNStructure;

AsnLen BEncRPNStructureContent PROTO((BUF_TYPE b, RPNStructure* v));

void BDecRPNStructureContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, RPNStructure* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintRPNStructure PROTO((FILE* f, RPNStructure* v, unsigned short int indent));
void FreeRPNStructure PROTO((RPNStructure* v));





typedef struct RPNQuery /* SEQUENCE */
{
    AsnOid attributeSetId; /* OBJECT IDENTIFIER */
    struct RPNStructure* rPNStructure; /* RPNStructure */
} RPNQuery;

AsnLen BEncRPNQueryContent PROTO((BUF_TYPE b, RPNQuery* v));

void BDecRPNQueryContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, RPNQuery* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintRPNQuery PROTO((FILE* f, RPNQuery* v, unsigned short int indent));
void FreeRPNQuery PROTO((RPNQuery* v));





typedef struct Query /* CHOICE */
{
    enum QueryChoiceId
    {
        QUERY_TYPE_0,
        QUERY_TYPE_1,
        QUERY_TYPE_2,
        QUERY_TYPE_100,
        QUERY_TYPE_101
    } choiceId;
    union QueryChoiceUnion
    {
    AsnOcts* type_0; /* [0] IMPLICIT OCTET STRING */
    struct RPNQuery* type_1; /* [1] IMPLICIT RPNQuery */
    AsnOcts* type_2; /* [2] OCTET STRING */
    AsnOcts* type_100; /* [100] OCTET STRING */
    AsnOcts* type_101; /* [101] IMPLICIT OCTET STRING */
    } a;
} Query;

AsnLen BEncQueryContent PROTO((BUF_TYPE b, Query* v));

void BDecQueryContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, Query* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintQuery PROTO((FILE* f, Query* v, unsigned short int indent));
void FreeQuery PROTO((Query* v));





typedef struct SearchReq /* SEQUENCE */
{
    ReferenceId referenceId; /* ReferenceId OPTIONAL */
    AsnInt smallSetUpperBound; /* [13] IMPLICIT INTEGER */
    AsnInt largeSetLowerBound; /* [14] IMPLICIT INTEGER */
    AsnInt mediumSetPresentNum; /* [15] IMPLICIT INTEGER */
    AsnBool replaceIndicator; /* [16] IMPLICIT BOOLEAN */
    VisibleString resultSetName; /* [17] IMPLICIT VisibleString */
    SearchReqSeqOf* databaseNames; /* [18] IMPLICIT SearchReqSeqOf */
    struct ElementSetNames* smallSetElementSetNames; /* [100] IMPLICIT ElementSetNames OPTIONAL */
    struct ElementSetNames* mediumSetElementSetNames; /* [101] IMPLICIT ElementSetNames OPTIONAL */
    PreferredRecordSyntax preferredRecordSyntax; /* PreferredRecordSyntax OPTIONAL */
    struct Query* query; /* [21] Query */
} SearchReq;

AsnLen BEncSearchReqContent PROTO((BUF_TYPE b, SearchReq* v));

void BDecSearchReqContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SearchReq* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintSearchReq PROTO((FILE* f, SearchReq* v, unsigned short int indent));
void FreeSearchReq PROTO((SearchReq* v));





typedef struct APDU /* CHOICE */
{
    enum APDUChoiceId
    {
        APDU_INITREQ,
        APDU_INITRESP,
        APDU_SEARCHREQ,
        APDU_SEARCHRESP,
        APDU_PRESENTREQ,
        APDU_PRESENTRESP,
        APDU_DELETERESULTSETREQ,
        APDU_DELETERESULTSETRESP,
        APDU_ACCESSCONTROLREQ,
        APDU_ACCESSCONTROLRESP,
        APDU_RESOURCECONTROLREQ,
        APDU_RESOURCECONTROLRESP,
        APDU_TRIGGERRESOURCEREQ,
        APDU_RESOURCEREPORTREQ,
        APDU_RESOURCEREPORTRESP
    } choiceId;
    union APDUChoiceUnion
    {
    struct InitializeReq* initReq; /* [20] IMPLICIT InitializeReq */
    struct InitializeResp* initResp; /* [21] IMPLICIT InitializeResp */
    struct SearchReq* searchReq; /* [22] IMPLICIT SearchReq */
    struct SearchResp* searchResp; /* [23] IMPLICIT SearchResp */
    struct PresentReq* presentReq; /* [24] IMPLICIT PresentReq */
    struct PresentResp* presentResp; /* [25] IMPLICIT PresentResp */
    struct DeleteResultSetReq* deleteResultSetReq; /* [26] IMPLICIT DeleteResultSetReq */
    struct DeleteResultSetResp* deleteResultSetResp; /* [27] IMPLICIT DeleteResultSetResp */
    struct AccessControlReq* accessControlReq; /* [28] IMPLICIT AccessControlReq */
    struct AccessControlResp* accessControlResp; /* [29] IMPLICIT AccessControlResp */
    struct ResourceControlReq* resourceControlReq; /* [30] IMPLICIT ResourceControlReq */
    struct ResourceControlResp* resourceControlResp; /* [31] IMPLICIT ResourceControlResp */
    struct TriggerResourceReq* triggerResourceReq; /* [32] IMPLICIT TriggerResourceReq */
    struct ResourceReportReq* resourceReportReq; /* [33] IMPLICIT ResourceReportReq */
    struct ResourceReportResp* resourceReportResp; /* [34] IMPLICIT ResourceReportResp */
    } a;
} APDU;

AsnLen BEncAPDU PROTO((BUF_TYPE b, APDU* v));

void BDecAPDU PROTO(( BUF_TYPE b, APDU* result, AsnLen* bytesDecoded, ENV_TYPE env));
AsnLen BEncAPDUContent PROTO((BUF_TYPE b, APDU* v));

void BDecAPDUContent PROTO(( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, APDU* v, AsnLen* bytesDecoded, ENV_TYPE env));


void PrintAPDU PROTO((FILE* f, APDU* v, unsigned short int indent));
void FreeAPDU PROTO((APDU* v));






#endif /* conditional include of ir.h */
#endif /* apdu.h */
