/*****************************************************************************
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *~                             IR Kernel                                    ~
 *~                         Copyright(C) 1993                                ~
 *~                       Software Kinetics Ltd.                             ~
 *~                        All Rights Reserved                               ~
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright Software Kinetics Ltd.
 * 
 * Software Kinetics Ltd. has granted a licence of this software to
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve,
 * reproduce and sell the software.
 *
 * The software is provided to the user "as is" without warranty of
 * any kind.  Neither Software Kinetics Ltd. nor the National Library
 * of Canada warrants,guarantees or makes any representation regarding
 * the use, or the results of the use of the software in terms of
 * accuracy,reliability, or otherwise.  The entire risk as results and
 * performance of the software is assumed by the user. Neither
 * Software Kinetics Ltd. nor the National Library of Canada shall be
 * liable for any direct, indirect, consequential or incidental
 * damages arising out the use of software.
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 *
 * Header:  tpconst.h
 *
 * Purpose: Global contant definitions header file.
 *
 * Index:   section number
 *          section description
 *
 * Version: 93/05/12
 *          Benjamin Yen
 *          reason for change
 *
 *  Notes:
 *
 *****************************************************************************/

/* tpconst.h   */

#define REQUIRED 1
#define OPTIONAL 0

#define NOTOK    1

#define EOS   '\0'

#ifndef TRUE
#define TRUE    1
#define FALSE   0
#endif

#define FAILED      -1
#define SUCCESS     0

#define ACTIVATE    1
#define DEACTIVATE  0

#define ONE_SECOND        1
/*
#define DEBUG_LEVEL1 1
#define DEBUG_LEVEL2 1
#define DEBUG_LEVEL3 1
*/

#define DEBUG_TESTING 1

#define ACCESS_CONTROL_BIT   0x02
#define RESOURCE_CONTROL_BIT 0x04
#define TRIGGER_RESOURCE_BIT 0x08
#define RESOURCE_REPORT_BIT  0x10
#define DELETE_BIT           0x20
#define PRESENT_BIT          0x40
#define SEARCH_BIT           0x80

#define SR_PROTOCOL_BIT 0x80
#define IR_PROTOCOL_BIT 0x40

#define CHECK_ACCESS_PASSWORD 1
#define CHECK_INIT_PASSWORD 2
